package com.bananahammock.auth;

import org.apache.http.cookie.Cookie;
import org.apache.http.impl.cookie.BasicClientCookie;

import java.io.Serializable;
import java.util.Date;

/**
 * Created by IntelliJ IDEA.
 * User: scott
 * Date: 9/14/11
 * Time: 9:41 AM
 * To change this template use File | Settings | File Templates.
 */
public class SerializableCookie implements Serializable {

    ////////////////////////////////////////////////////////////
	// Statics

    public static final long serialVersionUID = -1L;

    ////////////////////////////////////////////////////////////
	// Variables

    // TODO
    // Have to find javadoc/code to find out how to set
    // the commentUrl, isPersistent and ports

    private final String name;
    private final String value;
    private final String comment;
    private final String commentUrl;
    private final long expiryDate;
    private final boolean isPersistent;
    private final String domain;
    private final String path;
    private final int[] ports;
    private final boolean isSecure;
    private final int version;

    ////////////////////////////////////////////////////////////
	// Constructors

    public SerializableCookie(Cookie c) {
        this.name = c.getName();
        this.value = c.getValue();
        this.comment = c.getComment();
        this.commentUrl = c.getCommentURL();
        this.expiryDate = c.getExpiryDate().getTime();
        this.isPersistent = c.isPersistent();
        this.domain = c.getDomain();
        this.path = c.getPath();
        this.ports = c.getPorts();
        this.isSecure = c.isSecure();
        this.version = c.getVersion();
    }

    ////////////////////////////////////////////////////////////
	// Public Stuff

    public final Cookie fromSerialForm() {
        BasicClientCookie cookie = new BasicClientCookie(name, value);
        cookie.setComment(comment);
        cookie.setExpiryDate(new Date(expiryDate));
        cookie.setDomain(domain);
        cookie.setPath(path);
        cookie.setSecure(isSecure);
        cookie.setVersion(version);
        return cookie;
    }


}
